import os, sys
import subprocess


def call_file_as_subprocess(filepath, argumentlist=None, switchtodir=None, exitonerror=True):
    """ Method to Invoke a file as a subprocess. Will exit by deafault if the file not found
    Args:
        filepath (string): full path of the file to be executed
        argumentlist (list, optional): list of arguments that shall be passed
        switchtodir (string, optional): directory to switch before executing the file. Post execution script will switch back to the original current directory
        exitonerror (bool, optional): Fails/Stop the execution by default, override to false if needed
    """
    originaldirectory = os.getcwd()
    if (switchtodir != None):
        print("Switching to Directory:" + switchtodir)
        os.chdir(switchtodir)

    if os.path.isfile(filepath):
        print("Attempting to execute the file at " + filepath)
        if argumentlist == None:
            subprocess.call(filepath)
        else:
            subprocess.call([filepath, argumentlist])
    elif (exitonerror):
        sys.exit("The path " + filepath + " is not a valid file path")
    else:
        print("The path " + filepath + " is not a valid file path")
    print("Switching back to original directory post script execution: " + originaldirectory)
    os.chdir(originaldirectory)


def copy_files(source, destination):
    print("Mock Function to copy files, logic to to be added to include and exclude specific patterns")